(function(){
	function hookFunc(obj, name, matchCode, replaceCode) {
		try {
			var orgCode = obj[name].toString();
			var newCode = obj[name].toString().replace(matchCode, replaceCode);
			if (orgCode == newCode) {
				throw "MatchError:\n@matchCode: "+matchCode;
			} else {
				eval("obj[name]="+newCode);
			}
		} catch(ex) { Components.utils.reportError("[Personal-Titlebar] Failed to hook function: <"+obj+"."+name+"> "+ex+"\n"+newCode); }
	}
	// implement: allow drag-n-drop for all toolbar items
	hookFunc(window, "isToolbarItem", /return ([\S\s]+);/, 'return (aElt.localName != "toolbarpaletteitem");');
	hookFunc(window, "onToolbarDrop", 'if (wrapper.firstChild.getAttribute("removable") != "true")', "if (0)");
	// workaround: fix the 1st tab's title show as "New Tab"
	function update1stTabTitle() {
		var _tabs = window.arguments[0].ownerDocument.getElementById("tabbrowser-tabs");
		_tabs.tabbrowser.setTabTitle(_tabs.firstChild);
	}
	hookFunc(window, "initDialog", /}$/, "update1stTabTitle();$&");
	hookFunc(window, "dispatchCustomizationEvent", /}$/, "update1stTabTitle();$&");
})();

(function(){
	// implement: create customized checkboxs for menubar items display
	window.addEventListener("load", function(event) {
		window.removeEventListener("load", arguments.callee, false);
		// on checkbox clicked, control the display of menubar items
		var menubox = document.getElementById("menubar-menus-checkbox-container").firstChild;
		menubox.setVisibility = function(id, checked) {
			var menu = gToolboxDocument.getElementById(id);
			if (checked) menu.removeAttribute("invisible");
			else menu.setAttribute("invisible", true);
			gToolboxDocument.persist(id, "invisible");
		}
		// on restore button clicked, display all menubar items
		var resetbtn = document.getElementsByAttribute("icon", "revert")[0];
		resetbtn.resetAll = function() {
			for (var i=0; i<menubox.childNodes.length; i++) {
				var menu = menubox.childNodes[i];
				menubox.setVisibility(menu.id, menu.checked = true);
			}
			// also reset the [F10] "menubar-items" element's display
			menubox.setVisibility("menubar-items", true);
		}
		resetbtn.setAttribute("oncommand", "this.resetAll();"+resetbtn.getAttribute("oncommand"));
		// create all checkboxs on menubar-menus-checkbox-container
		var menubar = gToolboxDocument.getElementById("menubar-items").firstChild;
		for (var i=0; i<menubar.childNodes.length; i++) {
			var menu = menubar.childNodes[i];
			if (menu.localName != "menu") continue;
			var cbox = document.createElement("checkbox");
			cbox.id = menu.id;
			cbox.setAttribute("label", menu.label);
			cbox.setAttribute("checked", (menu.getAttribute("invisible") != "true"));
			cbox.setAttribute("oncommand", "this.parentNode.setVisibility(this.id, this.checked);");
			menubox.appendChild(cbox);
		}
	}, false);
})();
